diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/tx-duration-test.cc ns-3.38/src/wifi/test/tx-duration-test.cc
--- ns-3.37/src/wifi/test/tx-duration-test.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/test/tx-duration-test.cc	2023-03-16 20:54:23.872869300 -0700
@@ -274,6 +274,10 @@
     txVector.SetGuardInterval(guardInterval);
     txVector.SetStbc(0);
     txVector.SetNess(0);
+    if (IsEht(preamble))
+    {
+        txVector.SetEhtPpduType(0);
+    }
     std::list<uint16_t> staIds;
 
     uint16_t staId = 1;
@@ -1236,59 +1240,53 @@
     retval = retval &&
              CheckMuTxDuration(
                  std::list<uint32_t>{1536, 1536},
-                 std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, HePhy::GetHeMcs0(), 1},
-                                         {{HeRu::RU_242_TONE, 2, true}, HePhy::GetHeMcs0(), 1}},
+                 std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 0, 1},
+                                         {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
                  40,
                  800,
                  WIFI_PREAMBLE_HE_MU,
                  NanoSeconds(
                      1493600)) // equivalent to HE_SU for 20 MHz with 2 extra HE-SIG-B (i.e. 8 us)
-             && CheckMuTxDuration(
-                    std::list<uint32_t>{1536, 1536},
-                    std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, HePhy::GetHeMcs1(), 1},
-                                            {{HeRu::RU_242_TONE, 2, true}, HePhy::GetHeMcs0(), 1}},
-                    40,
-                    800,
-                    WIFI_PREAMBLE_HE_MU,
-                    NanoSeconds(1493600)) // shouldn't change if first PSDU is shorter
-             && CheckMuTxDuration(
-                    std::list<uint32_t>{1536, 76},
-                    std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, HePhy::GetHeMcs0(), 1},
-                                            {{HeRu::RU_242_TONE, 2, true}, HePhy::GetHeMcs0(), 1}},
-                    40,
-                    800,
-                    WIFI_PREAMBLE_HE_MU,
-                    NanoSeconds(1493600));
+             && CheckMuTxDuration(std::list<uint32_t>{1536, 1536},
+                                  std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 1, 1},
+                                                          {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
+                                  40,
+                                  800,
+                                  WIFI_PREAMBLE_HE_MU,
+                                  NanoSeconds(1493600)) // shouldn't change if first PSDU is shorter
+             && CheckMuTxDuration(std::list<uint32_t>{1536, 76},
+                                  std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 0, 1},
+                                                          {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
+                                  40,
+                                  800,
+                                  WIFI_PREAMBLE_HE_MU,
+                                  NanoSeconds(1493600));
 
     NS_TEST_EXPECT_MSG_EQ(retval, true, "an 802.11ax MU duration failed");
 
     // 802.11be MU durations
-    retval =
-        retval &&
-        CheckMuTxDuration(
-            std::list<uint32_t>{1536, 1536},
-            std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, EhtPhy::GetEhtMcs0(), 1},
-                                    {{HeRu::RU_242_TONE, 2, true}, EhtPhy::GetEhtMcs0(), 1}},
-            40,
-            800,
-            WIFI_PREAMBLE_EHT_MU,
-            NanoSeconds(1493600)) // equivalent to 802.11ax MU
-        && CheckMuTxDuration(
-               std::list<uint32_t>{1536, 1536},
-               std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, EhtPhy::GetEhtMcs1(), 1},
-                                       {{HeRu::RU_242_TONE, 2, true}, EhtPhy::GetEhtMcs0(), 1}},
-               40,
-               800,
-               WIFI_PREAMBLE_EHT_MU,
-               NanoSeconds(1493600)) // shouldn't change if first PSDU is shorter
-        && CheckMuTxDuration(
-               std::list<uint32_t>{1536, 76},
-               std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, EhtPhy::GetEhtMcs0(), 1},
-                                       {{HeRu::RU_242_TONE, 2, true}, EhtPhy::GetEhtMcs0(), 1}},
-               40,
-               800,
-               WIFI_PREAMBLE_EHT_MU,
-               NanoSeconds(1493600));
+    retval = retval &&
+             CheckMuTxDuration(std::list<uint32_t>{1536, 1536},
+                               std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 0, 1},
+                                                       {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
+                               40,
+                               800,
+                               WIFI_PREAMBLE_EHT_MU,
+                               NanoSeconds(1493600)) // equivalent to 802.11ax MU
+             && CheckMuTxDuration(std::list<uint32_t>{1536, 1536},
+                                  std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 1, 1},
+                                                          {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
+                                  40,
+                                  800,
+                                  WIFI_PREAMBLE_EHT_MU,
+                                  NanoSeconds(1493600)) // shouldn't change if first PSDU is shorter
+             && CheckMuTxDuration(std::list<uint32_t>{1536, 76},
+                                  std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 0, 1},
+                                                          {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
+                                  40,
+                                  800,
+                                  WIFI_PREAMBLE_EHT_MU,
+                                  NanoSeconds(1493600));
 
     NS_TEST_EXPECT_MSG_EQ(retval, true, "an 802.11be MU duration failed");
 
@@ -1310,7 +1308,7 @@
 
   private:
     /**
-     * Build a TXVECTOR for HE MU with the given bandwith and user informations.
+     * Build a TXVECTOR for HE MU with the given bandwidth and user information.
      *
      * \param bw the channel width of the PPDU in MHz
      * \param userInfos the list of HE MU specific user transmission parameters
@@ -1355,8 +1353,8 @@
 
     // 20 MHz band
     std::list<HeMuUserInfo> userInfos;
-    userInfos.push_back({{HeRu::RU_106_TONE, 1, true}, HePhy::GetHeMcs11(), 1});
-    userInfos.push_back({{HeRu::RU_106_TONE, 2, true}, HePhy::GetHeMcs10(), 4});
+    userInfos.push_back({{HeRu::RU_106_TONE, 1, true}, 11, 1});
+    userInfos.push_back({{HeRu::RU_106_TONE, 2, true}, 10, 4});
     WifiTxVector txVector = BuildTxVector(20, userInfos);
     txVector.SetSigBMode(VhtPhy::GetVhtMcs5());
     txVector.SetRuAllocation({96});
@@ -1375,10 +1373,10 @@
                           "HE-SIG-B should only last one OFDM symbol");
 
     // 40 MHz band, even number of users per HE-SIG-B content channel
-    userInfos.push_back({{HeRu::RU_52_TONE, 5, true}, HePhy::GetHeMcs4(), 1});
-    userInfos.push_back({{HeRu::RU_52_TONE, 6, true}, HePhy::GetHeMcs6(), 2});
-    userInfos.push_back({{HeRu::RU_52_TONE, 7, true}, HePhy::GetHeMcs5(), 3});
-    userInfos.push_back({{HeRu::RU_52_TONE, 8, true}, HePhy::GetHeMcs6(), 2});
+    userInfos.push_back({{HeRu::RU_52_TONE, 5, true}, 4, 1});
+    userInfos.push_back({{HeRu::RU_52_TONE, 6, true}, 6, 2});
+    userInfos.push_back({{HeRu::RU_52_TONE, 7, true}, 5, 3});
+    userInfos.push_back({{HeRu::RU_52_TONE, 8, true}, 6, 2});
     txVector = BuildTxVector(40, userInfos);
     txVector.SetSigBMode(VhtPhy::GetVhtMcs4());
     txVector.SetRuAllocation({96, 112});
@@ -1397,7 +1395,7 @@
                           "HE-SIG-B should only last one OFDM symbol");
 
     // 40 MHz band, odd number of users per HE-SIG-B content channel
-    userInfos.push_back({{HeRu::RU_26_TONE, 14, true}, HePhy::GetHeMcs3(), 1});
+    userInfos.push_back({{HeRu::RU_26_TONE, 14, true}, 3, 1});
     txVector = BuildTxVector(40, userInfos);
     txVector.SetSigBMode(VhtPhy::GetVhtMcs3());
     txVector.SetRuAllocation({96, 15});
@@ -1416,8 +1414,8 @@
                           "HE-SIG-B should last two OFDM symbols");
 
     // 80 MHz band
-    userInfos.push_back({{HeRu::RU_242_TONE, 3, true}, HePhy::GetHeMcs1(), 1});
-    userInfos.push_back({{HeRu::RU_242_TONE, 4, true}, HePhy::GetHeMcs4(), 1});
+    userInfos.push_back({{HeRu::RU_242_TONE, 3, true}, 1, 1});
+    userInfos.push_back({{HeRu::RU_242_TONE, 4, true}, 4, 1});
     txVector = BuildTxVector(80, userInfos);
     txVector.SetSigBMode(VhtPhy::GetVhtMcs1());
     txVector.SetRuAllocation({96, 15, 192, 192});
@@ -1436,7 +1434,7 @@
                           "HE-SIG-B should last four OFDM symbols");
 
     // 160 MHz band
-    userInfos.push_back({{HeRu::RU_996_TONE, 1, false}, HePhy::GetHeMcs1(), 1});
+    userInfos.push_back({{HeRu::RU_996_TONE, 1, false}, 1, 1});
     txVector = BuildTxVector(160, userInfos);
     txVector.SetSigBMode(VhtPhy::GetVhtMcs1());
     txVector.SetRuAllocation({96, 15, 192, 192, 208, 208, 208, 208});
@@ -1550,9 +1548,11 @@
     // -> long PPDU format
     txVector.SetPreambleType(WIFI_PREAMBLE_LONG);
     nonHtMode = DsssPhy::GetDsssRate1Mbps();
-    sections = {{WIFI_PPDU_FIELD_PREAMBLE, {{ppduStart, ppduStart + MicroSeconds(144)}, nonHtMode}},
-                {WIFI_PPDU_FIELD_NON_HT_HEADER,
-                 {{ppduStart + MicroSeconds(144), ppduStart + MicroSeconds(192)}, nonHtMode}}};
+    sections = {
+        {WIFI_PPDU_FIELD_PREAMBLE, {{ppduStart, ppduStart + MicroSeconds(144)}, nonHtMode}},
+        {WIFI_PPDU_FIELD_NON_HT_HEADER,
+         {{ppduStart + MicroSeconds(144), ppduStart + MicroSeconds(192)}, nonHtMode}},
+    };
     CheckPhyHeaderSections(phyEntity->GetPhyHeaderSections(txVector, ppduStart), sections);
 
     // -> long PPDU format if data rate is 1 Mbps (even if preamble is tagged short)
@@ -1563,9 +1563,11 @@
     txVector.SetMode(DsssPhy::GetDsssRate11Mbps());
     nonHtMode = DsssPhy::GetDsssRate2Mbps();
     txVector.SetPreambleType(WIFI_PREAMBLE_SHORT);
-    sections = {{WIFI_PPDU_FIELD_PREAMBLE, {{ppduStart, ppduStart + MicroSeconds(72)}, nonHtMode}},
-                {WIFI_PPDU_FIELD_NON_HT_HEADER,
-                 {{ppduStart + MicroSeconds(72), ppduStart + MicroSeconds(96)}, nonHtMode}}};
+    sections = {
+        {WIFI_PPDU_FIELD_PREAMBLE, {{ppduStart, ppduStart + MicroSeconds(72)}, nonHtMode}},
+        {WIFI_PPDU_FIELD_NON_HT_HEADER,
+         {{ppduStart + MicroSeconds(72), ppduStart + MicroSeconds(96)}, nonHtMode}},
+    };
     CheckPhyHeaderSections(phyEntity->GetPhyHeaderSections(txVector, ppduStart), sections);
 
     // ==================================================================================
@@ -1577,7 +1579,8 @@
         // number to use to deduce rate and BW info for each variant
         {OFDM_PHY_DEFAULT, 1},
         {OFDM_PHY_10_MHZ, 2},
-        {OFDM_PHY_5_MHZ, 4}};
+        {OFDM_PHY_5_MHZ, 4},
+    };
     for (auto variant : variants)
     {
         phyEntity = Create<OfdmPhy>(variant.first);
@@ -1586,11 +1589,13 @@
         txVector.SetChannelWidth(bw);
         txVector.SetMode(OfdmPhy::GetOfdmRate(12000000 / ratio, bw));
         nonHtMode = OfdmPhy::GetOfdmRate(6000000 / ratio, bw);
-        sections = {{WIFI_PPDU_FIELD_PREAMBLE,
-                     {{ppduStart, ppduStart + MicroSeconds(16 * ratio)}, nonHtMode}},
-                    {WIFI_PPDU_FIELD_NON_HT_HEADER,
-                     {{ppduStart + MicroSeconds(16 * ratio), ppduStart + MicroSeconds(20 * ratio)},
-                      nonHtMode}}};
+        sections = {
+            {WIFI_PPDU_FIELD_PREAMBLE,
+             {{ppduStart, ppduStart + MicroSeconds(16 * ratio)}, nonHtMode}},
+            {WIFI_PPDU_FIELD_NON_HT_HEADER,
+             {{ppduStart + MicroSeconds(16 * ratio), ppduStart + MicroSeconds(20 * ratio)},
+              nonHtMode}},
+        };
         CheckPhyHeaderSections(phyEntity->GetPhyHeaderSections(txVector, ppduStart), sections);
     }
 
@@ -1600,9 +1605,11 @@
     txVector.SetChannelWidth(20);
     txVector.SetMode(ErpOfdmPhy::GetErpOfdmRate(54000000));
     nonHtMode = ErpOfdmPhy::GetErpOfdmRate6Mbps();
-    sections = {{WIFI_PPDU_FIELD_PREAMBLE, {{ppduStart, ppduStart + MicroSeconds(16)}, nonHtMode}},
-                {WIFI_PPDU_FIELD_NON_HT_HEADER,
-                 {{ppduStart + MicroSeconds(16), ppduStart + MicroSeconds(20)}, nonHtMode}}};
+    sections = {
+        {WIFI_PPDU_FIELD_PREAMBLE, {{ppduStart, ppduStart + MicroSeconds(16)}, nonHtMode}},
+        {WIFI_PPDU_FIELD_NON_HT_HEADER,
+         {{ppduStart + MicroSeconds(16), ppduStart + MicroSeconds(20)}, nonHtMode}},
+    };
     CheckPhyHeaderSections(phyEntity->GetPhyHeaderSections(txVector, ppduStart), sections);
 
     // ==================================================================================
@@ -1625,7 +1632,8 @@
          {{ppduStart + MicroSeconds(20), ppduStart + MicroSeconds(28)}, htSigMode}},
         {WIFI_PPDU_FIELD_TRAINING,
          {{ppduStart + MicroSeconds(28), ppduStart + MicroSeconds(40)}, // 1 HT-STF + 2 HT-LTFs
-          htSigMode}}};
+          htSigMode}},
+    };
     CheckPhyHeaderSections(phyEntity->GetPhyHeaderSections(txVector, ppduStart), sections);
     txVector.SetChannelWidth(20); // shouldn't have any impact
     CheckPhyHeaderSections(phyEntity->GetPhyHeaderSections(txVector, ppduStart), sections);
@@ -1659,7 +1667,8 @@
          {{ppduStart + MicroSeconds(20), ppduStart + MicroSeconds(28)}, sigAMode}},
         {WIFI_PPDU_FIELD_TRAINING,
          {{ppduStart + MicroSeconds(28), ppduStart + MicroSeconds(56)}, // 1 VHT-STF + 6 VHT-LTFs
-          sigAMode}}};
+          sigAMode}},
+    };
     CheckPhyHeaderSections(phyEntity->GetPhyHeaderSections(txVector, ppduStart), sections);
 
     // -> VHT SU format for 7 SS
@@ -1688,24 +1697,25 @@
     txVector.SetNss(2); // HE-LTF duration assumed to be always 8 us for the time being (see note in
                         // HePhy::GetTrainingDuration)
     txVector.SetMode(HePhy::GetHeMcs9());
-    std::map<uint16_t, HeMuUserInfo> userInfoMap = {
-        {1, {{HeRu::RU_106_TONE, 1, true}, HePhy::GetHeMcs4(), 2}},
-        {2, {{HeRu::RU_106_TONE, 1, true}, HePhy::GetHeMcs9(), 1}}};
+    std::map<uint16_t, HeMuUserInfo> userInfoMap = {{1, {{HeRu::RU_106_TONE, 1, true}, 4, 2}},
+                                                    {2, {{HeRu::RU_106_TONE, 1, true}, 9, 1}}};
     sigAMode = HePhy::GetVhtMcs0();
     sigBMode = HePhy::GetVhtMcs4(); // because of first user info map
 
     // -> HE SU format
     txVector.SetPreambleType(WIFI_PREAMBLE_HE_SU);
-    sections = {{WIFI_PPDU_FIELD_PREAMBLE, {{ppduStart, ppduStart + MicroSeconds(16)}, nonHtMode}},
-                {WIFI_PPDU_FIELD_NON_HT_HEADER,
-                 {{ppduStart + MicroSeconds(16), ppduStart + MicroSeconds(24)}, // L-SIG + RL-SIG
-                  nonHtMode}},
-                {WIFI_PPDU_FIELD_SIG_A,
-                 {{ppduStart + MicroSeconds(24), ppduStart + MicroSeconds(32)}, sigAMode}},
-                {WIFI_PPDU_FIELD_TRAINING,
-                 {{ppduStart + MicroSeconds(32),
-                   ppduStart + MicroSeconds(52)}, // 1 HE-STF (@ 4 us) + 2 HE-LTFs (@ 8 us)
-                  sigAMode}}};
+    sections = {
+        {WIFI_PPDU_FIELD_PREAMBLE, {{ppduStart, ppduStart + MicroSeconds(16)}, nonHtMode}},
+        {WIFI_PPDU_FIELD_NON_HT_HEADER,
+         {{ppduStart + MicroSeconds(16), ppduStart + MicroSeconds(24)}, // L-SIG + RL-SIG
+          nonHtMode}},
+        {WIFI_PPDU_FIELD_SIG_A,
+         {{ppduStart + MicroSeconds(24), ppduStart + MicroSeconds(32)}, sigAMode}},
+        {WIFI_PPDU_FIELD_TRAINING,
+         {{ppduStart + MicroSeconds(32),
+           ppduStart + MicroSeconds(52)}, // 1 HE-STF (@ 4 us) + 2 HE-LTFs (@ 8 us)
+          sigAMode}},
+    };
     CheckPhyHeaderSections(phyEntity->GetPhyHeaderSections(txVector, ppduStart), sections);
 
     // -> HE ER SU format
@@ -1752,15 +1762,15 @@
 
     // ==================================================================================
     // 11be (EHT)
-    sections.erase(WIFI_PPDU_FIELD_SIG_A); // FIXME: do we keep using seperate type for 11be?
-    sections.erase(WIFI_PPDU_FIELD_SIG_B); // FIXME: do we keep using seperate type for 11be?
+    sections.erase(WIFI_PPDU_FIELD_SIG_A); // FIXME: do we keep using separate type for 11be?
+    sections.erase(WIFI_PPDU_FIELD_SIG_B); // FIXME: do we keep using separate type for 11be?
     phyEntity = Create<EhtPhy>();
     txVector.SetChannelWidth(20);
     txVector.SetNss(2); // EHT-LTF duration assumed to be always 8 us for the time being (see note
                         // in HePhy::GetTrainingDuration)
     txVector.SetMode(EhtPhy::GetEhtMcs9());
-    userInfoMap = {{1, {{HeRu::RU_106_TONE, 1, true}, EhtPhy::GetEhtMcs4(), 2}},
-                   {2, {{HeRu::RU_106_TONE, 1, true}, EhtPhy::GetEhtMcs9(), 1}}};
+    userInfoMap = {{1, {{HeRu::RU_106_TONE, 1, true}, 4, 2}},
+                   {2, {{HeRu::RU_106_TONE, 1, true}, 9, 1}}};
     WifiMode uSigMode = EhtPhy::GetVhtMcs0();
     WifiMode ehtSigMode = EhtPhy::GetVhtMcs4(); // because of first user info map
 
@@ -1778,6 +1788,7 @@
 
     // -> EHT MU format
     txVector.SetPreambleType(WIFI_PREAMBLE_EHT_MU);
+    txVector.SetEhtPpduType(0); // EHT MU transmission
     txVector.SetRuAllocation({96});
     sections[WIFI_PPDU_FIELD_U_SIG] = {{ppduStart + MicroSeconds(24), ppduStart + MicroSeconds(32)},
                                        uSigMode};
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/wifi-aggregation-test.cc ns-3.38/src/wifi/test/wifi-aggregation-test.cc
--- ns-3.37/src/wifi/test/wifi-aggregation-test.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/test/wifi-aggregation-test.cc	2023-03-16 20:54:23.872869300 -0700
@@ -173,7 +173,7 @@
     reqHdr.SetBufferSize(64);
     reqHdr.SetTimeout(0);
     reqHdr.SetStartingSequence(0);
-    m_mac->GetBEQueue()->GetBaManager()->CreateAgreement(&reqHdr, hdr.GetAddr1());
+    m_mac->GetBEQueue()->GetBaManager()->CreateOriginatorAgreement(reqHdr, hdr.GetAddr1());
 
     MgtAddBaResponseHeader respHdr;
     StatusCode code;
@@ -184,7 +184,7 @@
     respHdr.SetTid(reqHdr.GetTid());
     respHdr.SetBufferSize(64);
     respHdr.SetTimeout(reqHdr.GetTimeout());
-    m_mac->GetBEQueue()->GetBaManager()->UpdateAgreement(&respHdr, hdr.GetAddr1(), 0);
+    m_mac->GetBEQueue()->GetBaManager()->UpdateOriginatorAgreement(respHdr, hdr.GetAddr1(), 0);
 
     //-----------------------------------------------------------------------------------------------------
 
@@ -210,6 +210,7 @@
 
     // the packet has not been "transmitted", release its sequence number
     m_mac->m_txMiddle->SetSequenceNumberFor(&item->GetHeader());
+    item->UnassignSeqNo();
 
     //-----------------------------------------------------------------------------------------------------
 
@@ -501,7 +502,7 @@
     reqHdr.SetBufferSize(64);
     reqHdr.SetTimeout(0);
     reqHdr.SetStartingSequence(0);
-    m_mac->GetVIQueue()->GetBaManager()->CreateAgreement(&reqHdr, hdr.GetAddr1());
+    m_mac->GetVIQueue()->GetBaManager()->CreateOriginatorAgreement(reqHdr, hdr.GetAddr1());
 
     MgtAddBaResponseHeader respHdr;
     StatusCode code;
@@ -512,7 +513,7 @@
     respHdr.SetTid(reqHdr.GetTid());
     respHdr.SetBufferSize(64);
     respHdr.SetTimeout(reqHdr.GetTimeout());
-    m_mac->GetVIQueue()->GetBaManager()->UpdateAgreement(&respHdr, hdr.GetAddr1(), 0);
+    m_mac->GetVIQueue()->GetBaManager()->UpdateOriginatorAgreement(respHdr, hdr.GetAddr1(), 0);
 
     m_mac->SetAttribute("VI_MaxAmsduSize", UintegerValue(3050)); // max 2 MSDUs per A-MSDU
     m_mac->SetAttribute("VI_MaxAmpduSize", UintegerValue(65535));
@@ -584,7 +585,7 @@
  * \ingroup tests
  *
  * \brief 802.11ax aggregation test which permits 64 or 256 MPDUs in A-MPDU according to the
- * negociated buffer size.
+ * negotiated buffer size.
  */
 class HeAggregationTest : public TestCase
 {
@@ -694,7 +695,7 @@
     reqHdr.SetBufferSize(bufferSize);
     reqHdr.SetTimeout(0);
     reqHdr.SetStartingSequence(0);
-    m_mac->GetBEQueue()->GetBaManager()->CreateAgreement(&reqHdr, hdr.GetAddr1());
+    m_mac->GetBEQueue()->GetBaManager()->CreateOriginatorAgreement(reqHdr, hdr.GetAddr1());
 
     MgtAddBaResponseHeader respHdr;
     StatusCode code;
@@ -705,10 +706,10 @@
     respHdr.SetTid(reqHdr.GetTid());
     respHdr.SetBufferSize(bufferSize);
     respHdr.SetTimeout(reqHdr.GetTimeout());
-    m_mac->GetBEQueue()->GetBaManager()->UpdateAgreement(&respHdr, hdr.GetAddr1(), 0);
+    m_mac->GetBEQueue()->GetBaManager()->UpdateOriginatorAgreement(respHdr, hdr.GetAddr1(), 0);
 
     /*
-     * Test behavior when 300 packets are ready for transmission but negociated buffer size is 64
+     * Test behavior when 300 packets are ready for transmission but negotiated buffer size is 64
      */
     Ptr<HtFrameExchangeManager> htFem = DynamicCast<HtFrameExchangeManager>(fem);
     Ptr<MpduAggregator> mpduAggregator = htFem->GetMpduAggregator();
@@ -741,7 +742,7 @@
     NS_TEST_EXPECT_MSG_EQ(mpduList.empty(), false, "MPDU aggregation failed");
     NS_TEST_EXPECT_MSG_EQ(mpduList.size(),
                           bufferSize,
-                          "A-MPDU should countain " << bufferSize << " MPDUs");
+                          "A-MPDU should contain " << bufferSize << " MPDUs");
     uint16_t expectedRemainingPacketsInQueue = 300 - bufferSize;
     NS_TEST_EXPECT_MSG_EQ(m_mac->GetBEQueue()->GetWifiMacQueue()->GetNPackets(),
                           expectedRemainingPacketsInQueue,
